#[doc = "Register `BUPDIV` reader"]
pub type R = crate::R<BupdivSpec>;
#[doc = "Register `BUPDIV` writer"]
pub type W = crate::W<BupdivSpec>;
#[doc = "Backup Clock Division Factor\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq, Eq)]
#[repr(u8)]
pub enum Bupdivselect {
    #[doc = "1: Divide by 1"]
    Div1 = 1,
    #[doc = "2: Divide by 2"]
    Div2 = 2,
    #[doc = "4: Divide by 4"]
    Div4 = 4,
    #[doc = "8: Divide by 8"]
    Div8 = 8,
    #[doc = "16: Divide by 16"]
    Div16 = 16,
    #[doc = "32: Divide by 32"]
    Div32 = 32,
    #[doc = "64: Divide by 64"]
    Div64 = 64,
    #[doc = "128: Divide by 128"]
    Div128 = 128,
}
impl From<Bupdivselect> for u8 {
    #[inline(always)]
    fn from(variant: Bupdivselect) -> Self {
        variant as _
    }
}
impl crate::FieldSpec for Bupdivselect {
    type Ux = u8;
}
impl crate::IsEnum for Bupdivselect {}
#[doc = "Field `BUPDIV` reader - Backup Clock Division Factor"]
pub type BupdivR = crate::FieldReader<Bupdivselect>;
impl BupdivR {
    #[doc = "Get enumerated values variant"]
    #[inline(always)]
    pub const fn variant(&self) -> Option<Bupdivselect> {
        match self.bits {
            1 => Some(Bupdivselect::Div1),
            2 => Some(Bupdivselect::Div2),
            4 => Some(Bupdivselect::Div4),
            8 => Some(Bupdivselect::Div8),
            16 => Some(Bupdivselect::Div16),
            32 => Some(Bupdivselect::Div32),
            64 => Some(Bupdivselect::Div64),
            128 => Some(Bupdivselect::Div128),
            _ => None,
        }
    }
    #[doc = "Divide by 1"]
    #[inline(always)]
    pub fn is_div1(&self) -> bool {
        *self == Bupdivselect::Div1
    }
    #[doc = "Divide by 2"]
    #[inline(always)]
    pub fn is_div2(&self) -> bool {
        *self == Bupdivselect::Div2
    }
    #[doc = "Divide by 4"]
    #[inline(always)]
    pub fn is_div4(&self) -> bool {
        *self == Bupdivselect::Div4
    }
    #[doc = "Divide by 8"]
    #[inline(always)]
    pub fn is_div8(&self) -> bool {
        *self == Bupdivselect::Div8
    }
    #[doc = "Divide by 16"]
    #[inline(always)]
    pub fn is_div16(&self) -> bool {
        *self == Bupdivselect::Div16
    }
    #[doc = "Divide by 32"]
    #[inline(always)]
    pub fn is_div32(&self) -> bool {
        *self == Bupdivselect::Div32
    }
    #[doc = "Divide by 64"]
    #[inline(always)]
    pub fn is_div64(&self) -> bool {
        *self == Bupdivselect::Div64
    }
    #[doc = "Divide by 128"]
    #[inline(always)]
    pub fn is_div128(&self) -> bool {
        *self == Bupdivselect::Div128
    }
}
#[doc = "Field `BUPDIV` writer - Backup Clock Division Factor"]
pub type BupdivW<'a, REG> = crate::FieldWriter<'a, REG, 8, Bupdivselect>;
impl<'a, REG> BupdivW<'a, REG>
where
    REG: crate::Writable + crate::RegisterSpec,
    REG::Ux: From<u8>,
{
    #[doc = "Divide by 1"]
    #[inline(always)]
    pub fn div1(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div1)
    }
    #[doc = "Divide by 2"]
    #[inline(always)]
    pub fn div2(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div2)
    }
    #[doc = "Divide by 4"]
    #[inline(always)]
    pub fn div4(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div4)
    }
    #[doc = "Divide by 8"]
    #[inline(always)]
    pub fn div8(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div8)
    }
    #[doc = "Divide by 16"]
    #[inline(always)]
    pub fn div16(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div16)
    }
    #[doc = "Divide by 32"]
    #[inline(always)]
    pub fn div32(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div32)
    }
    #[doc = "Divide by 64"]
    #[inline(always)]
    pub fn div64(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div64)
    }
    #[doc = "Divide by 128"]
    #[inline(always)]
    pub fn div128(self) -> &'a mut crate::W<REG> {
        self.variant(Bupdivselect::Div128)
    }
}
impl R {
    #[doc = "Bits 0:7 - Backup Clock Division Factor"]
    #[inline(always)]
    pub fn bupdiv(&self) -> BupdivR {
        BupdivR::new(self.bits)
    }
}
impl W {
    #[doc = "Bits 0:7 - Backup Clock Division Factor"]
    #[inline(always)]
    pub fn bupdiv(&mut self) -> BupdivW<BupdivSpec> {
        BupdivW::new(self, 0)
    }
}
#[doc = "Backup Clock Division\n\nYou can [`read`](crate::Reg::read) this register and get [`bupdiv::R`](R). You can [`reset`](crate::Reg::reset), [`write`](crate::Reg::write), [`write_with_zero`](crate::Reg::write_with_zero) this register using [`bupdiv::W`](W). You can also [`modify`](crate::Reg::modify) this register. See [API](https://docs.rs/svd2rust/#read--modify--write-api)."]
pub struct BupdivSpec;
impl crate::RegisterSpec for BupdivSpec {
    type Ux = u8;
}
#[doc = "`read()` method returns [`bupdiv::R`](R) reader structure"]
impl crate::Readable for BupdivSpec {}
#[doc = "`write(|w| ..)` method takes [`bupdiv::W`](W) writer structure"]
impl crate::Writable for BupdivSpec {
    type Safety = crate::Unsafe;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: u8 = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: u8 = 0;
}
#[doc = "`reset()` method sets BUPDIV to value 0x01"]
impl crate::Resettable for BupdivSpec {
    const RESET_VALUE: u8 = 0x01;
}
